%define __libtoolize :
%define pam_ldap_version 178
%define db_version 4.0.14
%define momorel 1
Summary: NSS library and PAM module for LDAP.
Name: nss_ldap
Version: 239
Release: %{momorel}m
Source0: http://ftp.padl.com/download/%{name}-%{version}.tar.gz
Source1: http://ftp.padl.com/download/pam_ldap-%{pam_ldap_version}.tar.gz
Source2: ftp://sleepycat1.inetu.net/releases/db-%{db_version}.tar.gz
Source3: nss_ldap.versions
Source4: pam_ldap.versions
Patch1: pam_ldap-176-dnsconfig.patch
Patch2: nss_ldap-207-lib64.patch
# http://bugzilla.padl.com/show_bug.cgi?id=211
Patch3: nss_ldap-239-tls-security-bug.patch
# http://bugzilla.padl.com/show_bug.cgi?id=210
Patch4: pam_ldap-176-fix-referral-tls.patch

URL: http://www.padl.com/
License: LGPL
Group: System Environment/Base
BuildRoot: %{_tmppath}/%{name}-%{version}-root
# BuildPrereq: cyrus-sasl-devel >= 1.5.24-14, gdbm-devel, krb5-devel
# BuildPrereq: openldap-devel, openssl-devel
BuildPreReq: autoconf >= 2.52-8k, automake >= 1.5-8k                      
BuildPrereq: cyrus-sasl-devel >= 1.5.24-12k, gdbm-devel
BuildPrereq: openldap-devel >= 2.1.22-2m, openssl-devel
BuildPrereq: e2fsprogs-devel
Requires: nscd
Obsoletes: pam_ldap
NoSource: 0
NoSource: 1
NoSource: 2

%description
This package includes two LDAP access clients: nss_ldap and pam_ldap.
Nss_ldap is a set of C library extensions which allows X.500 and LDAP
directory servers to be used as a primary source of aliases, ethers,
groups, hosts, networks, protocol, users, RPCs, services and shadow
passwords (instead of or in addition to using flat files or NIS).

Pam_ldap is a module for Linux-PAM that supports password changes, V2
clients, Netscapes SSL, ypldapd, Netscape Directory Server password
policies, access authorization, crypted hashes, etc.

Install nss_ldap if you need LDAP access clients.

%prep
%setup -q -c -a 1 -a 2

cp nss_ldap-%{version}/resolve.c pam_ldap-%{pam_ldap_version}/
cp nss_ldap-%{version}/resolve.h pam_ldap-%{pam_ldap_version}/
cp nss_ldap-%{version}/snprintf.c pam_ldap-%{pam_ldap_version}/
cp nss_ldap-%{version}/snprintf.h pam_ldap-%{pam_ldap_version}/

pushd pam_ldap-%{pam_ldap_version}
%patch1 -p1 -b .dnsconfig
%patch4 -p1 -b .pam_tls
aclocal
automake -a
autoheader
autoconf
popd

pushd nss_ldap-%{version}
%if %{_lib} == "lib64"
%patch2 -p1 -b .lib64~
%endif
%patch3 -p0 -b .nss_tls
popd

rm -f pam.d/*.pam_console

cp nss_ldap-%{version}/ANNOUNCE             ANNOUNCE.nss_ldap
cp nss_ldap-%{version}/AUTHORS              AUTHORS.nss_ldap
cp nss_ldap-%{version}/ChangeLog            ChangeLog.nss_ldap
cp nss_ldap-%{version}/COPYING              COPYING.nss_ldap
cp nss_ldap-%{version}/NEWS                 NEWS.nss_ldap
cp nss_ldap-%{version}/README               README.nss_ldap
cp nss_ldap-%{version}/nsswitch.ldap        nsswitch.ldap
cp pam_ldap-%{pam_ldap_version}/AUTHORS     AUTHORS.pam_ldap
cp pam_ldap-%{pam_ldap_version}/ChangeLog   ChangeLog.pam_ldap
cp pam_ldap-%{pam_ldap_version}/COPYING     COPYING.pam_ldap
cp pam_ldap-%{pam_ldap_version}/COPYING.LIB COPYING.LIB.pam_ldap
cp pam_ldap-%{pam_ldap_version}/NEWS        NEWS.pam_ldap
cp pam_ldap-%{pam_ldap_version}/README      README.pam_ldap

%build
# Set the CFLAGS to make sure -fPIC is *always* used.
CFLAGS="%{optflags} -fPIC"; export CFLAGS
topdir=`pwd`/db-instroot
target_platform=%{_target_platform}
%define _target_platform --target=${target_platform}

# Build db4.
pushd db-%{db_version}/dist
./configure --disable-shared --prefix=${topdir} --enable-compat185 --with-uniquename=_nss_ldap
make
make install
popd

# Use the bundled libdb from here on out.
CPPFLAGS=-I${topdir}/include
export CPPFLAGS
CFLAGS="-I${topdir}/include $CFLAGS"
export CFLAGS
LDFLAGS=-L${topdir}/lib
export LDFLAGS

# Build pam_ldap.
pushd pam_ldap-%{pam_ldap_version}
%configure --libdir=/%{_lib} --host=%{_target_cpu}-linux --build=%{_target_cpu}-linux --program-transform-name=""
make

# Relink using the version script.
rm pam_ldap.so
make pam_ldap_so_LDFLAGS="-shared -Wl,--version-script=$RPM_SOURCE_DIR/pam_ldap.versions"
popd

# Build nss_ldap, linking statically with libraries which live outside of /lib.
pushd nss_ldap-%{version}
STATICLIBS="-lldap -llber -lsasl2 -lcom_err"
SHAREDLIBS="-lgdbm -lssl -lcrypto -ldb -ldl -lresolv -lc"
LIBS="-Wl,-Bstatic $STATICLIBS -Wl,-Bdynamic $SHAREDLIBS"
export LIBS

echo "#undef CONFIGURE_KRB5_CCNAME" >> acconfig.h
aclocal-old && automake-old && autoheader-old && autoconf-old
%configure \
	--with-ldap=openldap \
	--libdir=/%{_lib} \
	--enable-schema-mapping \
	--enable-rfc2307bis \
	--program-transform-name=""
make

# Relink using the version script, pulling in the needed libraries statically.
rm nss_ldap.so
make LIBS="$LIBS" nss_ldap_so_LDFLAGS="-shared -Wl,--version-script=$RPM_SOURCE_DIR/nss_ldap.versions -Wl,-soname=libnss_ldap.so.2"
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
mkdir -p %{buildroot}/{etc,%{_lib}/security,%{_libdir}}

# Let the nss_ldap install target do its thing.
make -C nss_ldap-%{version} \
	install DESTDIR=%{buildroot} INST_UID=`id -un` INST_GID=`id -gn`

# Install the nsswitch module in a fashion similar to those which are
# part of glibc.
libcver=`basename /%{_lib}/libnss_files-*.so .so | cut -f2 -d-`
install -m755 nss_ldap-%{version}/nss_ldap.so \
	%{buildroot}/%{_lib}/libnss_ldap-${libcver}.so

# Create a symlink from libdir to /lib.
install -m755 -d %{buildroot}/%{_libdir}
touch %{buildroot}/rootfile
root=..
while [ ! -e %{buildroot}/%{_libdir}/${root}/rootfile ] ; do
	root=${root}/..
done
pushd %{buildroot}/%{_libdir}
ln -s ${root}/%{_lib}/libnss_ldap-*.so libnss_ldap.so
popd

# Install the module for PAM.
pushd pam_ldap-%{pam_ldap_version}
install -m755 -d %{buildroot}/%{_lib}/security
install -m755 pam_ldap.so %{buildroot}/%{_lib}/security/
make DESTDIR=%{buildroot} install-man

# Install the default configuration file, but change the search bases to
# something generic to avoid overloading padl.com servers and to match
# good practice when using DNS domains in example configurations.
sed 's|dc=padl|dc=example|g' ldap.conf > %{buildroot}/etc/ldap.conf
chmod 644 %{buildroot}/etc/ldap.conf
popd

rm -rf %{buildroot}/rootfile
rm -f %{buildroot}/etc/nsswitch.ldap

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# Need to run ldconfig, because older versions of this package included
# the symlink ldconfig now manages.
%triggerun -- nss_ldap < 184
/sbin/ldconfig

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%defattr(-,root,root)
%attr(0755,root,root) /%{_lib}/libnss_ldap-*.so
%attr(0755,root,root) /%{_lib}/security/*.so*
%attr(0755,root,root) %{_libdir}/*.so
%attr(0644,root,root) %config(noreplace) /etc/ldap.conf
%{_mandir}/man5/*
%doc nsswitch.ldap *.nss_ldap *.pam_ldap pam_ldap-%{pam_ldap_version}/pam.d

%changelog
* Mon Jul 25 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (239-1m)
- up to nss_ldap 239
- up to pam_ldap 178
- [SECURITY] CAN-2005-2069

* Tue Feb 15 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (207-6m)
- enable x86_64.

* Sun Jan 16 2005 Toru Hoshina <t@momonga-linux.org>
- (207-5m)
- enable x86_64.

* Wed May 19 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (207-4m)
- change URI

* Thu Mar 25 2004 Toru Hoshina <t@momonga-linux.org>
- (207-3m)
- revised spec for rpm 4.2.

* Mon Nov 10 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (207-2m)
- rebuild against openldap

* Thu Jul 17 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (207-1m)
- makimodoshi at original site
- add BuildPreReq: e2fsprogs-devel

* Thu Jun 19 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (209-1m)
  nss_ldap update to 209
  pam_ldap update to 164

* Wed Jun 18 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (203.6-4m)
  for cyrus-sasl2

* Sun Mar  9 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (203.6-3m)
  rebuild against openssl 0.9.7a

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (203.6-2m)
- rebuild against for gdbm

* Fri Feb  7 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (203.6-1m)
  update to 203.6

* Wed Jan 22 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (203-3m)
- update pam_ldap_version to 159
- change URI to ftp
- adapt Patch1: pam_ldap-148-dnsconfig.patch to pam_ldap-159 (pam_ldap.h)

* Mon Jan 13 2003 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (203-2m)
- fix Source URI.

* Sat Jan 4 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (203-1m)
- update nss_ldap 203
- update pam_ldap 157
- delete patch0

* Wed Jun 19 2002 Tsutomu Yasuda <tom@kondara.org>
- (194-2k)
  update to nss_ldap 194, pam_ldap 148
  security fix
  http://online.securityfocus.com/advisories/4152

* Mon May 13 2002 Toru Hoshina <t@kondara.org>
- (185-2k)
- ver up.

* Thu Feb 21 2002 Shingo Akagaki <dora@kondara.org>
- (173-8k)
- rebuild against for db3,4

* Wed Feb 20 2002 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>    
- (173-6k)
- add BuildPreReq: autoconf >= 2.52-8k, automake >= 1.5-8k 

* Fri Nov 02 2001 Motonobu Ichimura <famao@kondara.org>
- (172-2k)
- up to 173 (adopted from rawhide 172-3)
- include pam_ldap's tar ball

* Sat May 22 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (150-2k)
- from rawhide, against "Mary".
- NoSrc nss_ldap and pam_ldap
- remove Kerberos from spec.
- rework nss_ldap-140-redhat.patch to nss_ldap-150-kondara.patch
-  o  remove Kerberos
-  o  remove static linking in configure.in
- update to pam_ldap 108

* Wed Apr 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to pam_ldap 107

* Thu Apr 19 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 150 (incorporates the fail patch)
- update to pam_ldap 106

* Wed Mar  7 2001 Nalin Dahyabhai <nalin@redhat.com>
- make nss_ldap fail when attempting to startup TLS fails, because that's what
  we do when LDAPS doesn't work (and what pam_ldap does already)
- add DNS autoconfiguration to pam_ldap

* Tue Mar  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 149, minor fixes for compile glitches
- update to pam_ldap 105, minor fixes (as above) and handles shadow expiration

* Fri Mar  2 2001 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Wed Feb 28 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 146 to get a faster initgroups() back-end

* Mon Feb 12 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 143 to get the official fix for the heap corruption

* Fri Feb  9 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix heap corruption when falling back to DNS SRV records for configuration

* Mon Feb  5 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 142, fixes a memory leak

* Mon Jan 29 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 140, fixes a configure bug and an alignment problem

* Fri Jan 19 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 139

* Mon Jan 15 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 138, which folds in our patch for initgroups
- change the default search base in ldap.conf to dc=example,dc=com

* Wed Jan 10 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 137 and pam_ldap 99
- try to not cause a segfault in _nss_ldap_initgroups

* Wed Jan  3 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 124 and pam_ldap 82

* Thu Dec 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- add a requires: for nscd

* Thu Dec 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- version the NSS module so that it works properly with programs which have
  been linked statically to a different version of an LDAP library, like
  Netscape Communicator

* Wed Dec  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- BuildPrereq gdbm-devel
- pass RPM_OPT_FLAGS as CFLAGS to %%configure
- if protocol version is 2, explicitly set protocol version to 3 before trying
  to start TLS
- add STARTTLS support to nss_ldap
- work around a build-time problem on ia64

* Tue Dec  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- BuildPrereq cyrus-sasl-devel instead of cyrus-sasl

* Mon Nov 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 123 and pam_ldap 82

* Fri Oct 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 122
- link statically with libsasl, require the first devel package that supplied it

* Thu Oct 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 120 and pam_ldap 77

* Wed Oct  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 116 and pam_ldap 74

* Fri Sep  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Thu Jul 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to pam_ldap 67 to fix a bug in template user code
- convert symlink in /usr/lib to a relative one (#16132)

* Thu Jul 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 113 and pam_ldap 66

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jun 27 2000 Matt Wilson <msw@redhat.com>
- changed all the -,- in attr statements to root,root

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- update pam_ldap to 63

* Wed May 31 2000 Nalin Dahyabhai <nalin@redhat.com>
- update pam_ldap to 56

* Tue May 30 2000 Nalin Dahyabhai <nalin@redhat.com>
- update pam_ldap to 55
- back out no-threads patch for pam_ldap, not needed any more

* Thu May 25 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 110
- revert prototype patch, looks like a problem with the new glibc after all

* Fri May 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- get libpthread out of the NSS module
- fix prototype problems in getpwXXX()

* Mon May 15 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 109

* Sat Apr 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- update pam_ldap 51

* Tue Apr 25 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 108 and pam_ldap 49

* Thu Apr 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to pam_ldap 48

* Thu Mar 30 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 107
- note: check http://www.advogato.org/person/lukeh/ for Luke's changelog

* Tue Mar 21 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 106

* Wed Feb  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 105

* Mon Feb  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 104 and pam_ldap 46
- disable link against libpthread in pam_ldap

* Tue Feb  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove migration tools, because this package requires openldap now, which
  also includes them

* Fri Jan 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to nss_ldap 103

* Mon Jan 24 2000 Preston Brown <pbrown@redhat.com>
- fix typo in linuxconf-pair pam cfg file (#7800)

* Tue Jan 11 2000 Preston Brown <pbrown@redhat.com>
- v99, made it require pam_ldap
- added perl migration tools
- integrate pam_ldap stuff

* Fri Oct 22 1999 Bill Nottingham <notting@redhat.com>
- statically link ldap libraries (they're in /usr/lib)

* Tue Aug 10 1999 Cristian Gafton <gafton@redhat.com>
- use the ldap.conf file as an external source
- don't forcibly build the support for version 3
- imported the default spec file from the tarball and fixed it up for RH 6.1
